/*
Initialize by calling 
  poke_gamepad_poll_function()
Then invoke using:
  __asm__("jsr 830");
or	
  __asm__("jsr 0x033E");
	
Example:
....
	poke_gamepad_poll_function();
	
	while (TRUE)
	{
		__asm__("jsr 830");  // jump to the polling function, it'll RTS back to here at the end
		
		g_padA = PEEK(0x033A);   // declare g_padA as unsigned char
		g_padB = PEEK(0x033B);   // declare g_padB as unsigned char
		
		...
	}
	
*/
// WARNING: While this function starts at $033E, the results are written in $033A-$033B (and $033C is used as a shift mask)
void poke_gamepad_poll_function()
{  // Code instructions taken verbatim from Joe Travis SNESTEST.PRG BASIC DATA section (poke address 830 to 905)
	POKE(0x033E, 0xA9);  // LDA
	POKE(0x033F, 0x28);
	POKE(0x0340, 0x8D);  // STA
	POKE(0x0341, 0x43);
	POKE(0x0342, 0xE8);
  POKE(0x0343, 0xA9);  // LDA
	POKE(0x0344, 0x00);
	POKE(0x0345, 0x8D);  // STA
	POKE(0x0346, 0x3A);
	POKE(0x0347, 0x03);
	POKE(0x0348, 0x8D);  // STA
	POKE(0x0349, 0x3B);
	POKE(0x034A, 0x03);
	POKE(0x034B, 0xA9);  // LDA
	POKE(0x034C, 0x08);
  POKE(0x034D, 0x8D);  // STA
	POKE(0x034E, 0x3C);  
	POKE(0x034F, 0x03);
	POKE(0x0350, 0xA2);  // LDX
	POKE(0x0351, 0x0C);
	POKE(0x0352, 0xA0);  // LDY
	POKE(0x0353, 0x01);
  POKE(0x0354, 0xA9);  // LDA
	POKE(0x0355, 0x20);
	POKE(0x0356, 0x8D);  // STA
	POKE(0x0357, 0x41);  
	POKE(0x0358, 0xE8);
	POKE(0x0359, 0xA9);  // LDA
	POKE(0x035A, 0x00);
	POKE(0x035B, 0x8D);  // STA
	POKE(0x035C, 0x41);
	POKE(0x035D, 0xE8);
  POKE(0x035E, 0xAD);  // LDA
	POKE(0x035F, 0x41);
	POKE(0x0360, 0xE8);
	POKE(0x0361, 0x29);  // AND
	POKE(0x0362, 0x40);
	POKE(0x0363, 0xC9);  // CMP
	POKE(0x0364, 0x40);
	POKE(0x0365, 0xF0);  // BEQ
	POKE(0x0366, 0x09);
	POKE(0x0367, 0xAD);  // LDA
	POKE(0x0368, 0x3C);
	POKE(0x0369, 0x03);
	POKE(0x036A, 0x19);  // ORA
	POKE(0x036B, 0x3A);
	POKE(0x036C, 0x03);
	POKE(0x036D, 0x99);  // STA
	POKE(0x036E, 0x3A);
	POKE(0x036F, 0x03);
  POKE(0x0370, 0xAD);  // LDA
	POKE(0x0371, 0x3C);
	POKE(0x0372, 0x03);
	POKE(0x0373, 0x4A);  // LSR
	POKE(0x0374, 0xD0);  // BNE
	POKE(0x0375, 0x03);
	POKE(0x0376, 0x88);  // DEY
	POKE(0x0377, 0xA9);  // LDA
	POKE(0x0378, 0x80);
  POKE(0x0379, 0x8D);  // STA
	POKE(0x037A, 0x3C);
	POKE(0x037B, 0x03);
	POKE(0x037C, 0xA9);  // LDA
	POKE(0x037D, 0x08);
	POKE(0x037E, 0x8D);  // STA
	POKE(0x037F, 0x41);
	POKE(0x0380, 0xE8);
	POKE(0x0381, 0xA9);  // LDA
	POKE(0x0382, 0x00);
  POKE(0x0383, 0x8D);  // STA
	POKE(0x0384, 0x41);  
	POKE(0x0385, 0xE8);
	POKE(0x0386, 0xCA);  // DEX	
	POKE(0x0387, 0xD0);  // BNE
	POKE(0x0388, 0xD5);	
	POKE(0x0389, 0x60);  // RTS	
}
